;#######################################################################################################
; Text_Layer_Routines
;(c) Kai Scheddin 16.07.07
;
; Main Frame -> to CG-Ram
; Layer 1,2,3,4 -> Main Frame
; For Graphic colors graph_layer1
;#######################################################################################################
#ifndef _T_L_R_ASM_
#define _T_L_R_ASM_

.include "graphic/asm/t_l_macros.mcr"


;#######################################################################################################
;Routine text_layer_init
;initiate text layer buffer and the graphics buffer configuration register
;#######################################################################################################
text_layer_init:
push r0
push r16
push r30
push r31



;set TLCR
ldi r17,0b11111000 ;sets TLALO,TLND3-0
ldi r16,0x00
PUT_TLCR r17,r16

;set TLPR
ldi r16,low(TLDATA)
ldi r17,high(TLDATA)
PUT_TLPR r17,r16

      
;set start address
clr r16
clr r17
PUT_TLDATA_VIEW_START r17,r16
rcall set_text_layer_pointer_to_view_start
rcall set_text_layer_view_end_normal_distance




pop r31
pop r30
pop r16
pop r0

ret
;#######################################################################################################

;#######################################################################################################

;#######################################################################################################
;Routine clear_text_layer
;sets the hole text_layer to zero
;#######################################################################################################
clear_text_layer:
rcall set_text_layer_pointer_to_view_start
push r14
push r15
push r16
push r17
push r18

clr r18

GET_TLDATA_END r17,r16

Clear_text_layer_1:
PUT_TLDATA r18
INC_TLPR
GET_TLPR r15,r14
cp r14,r16
cpc r17,r15
brne Clear_text_layer_1


pop r18
pop r17
pop r16
pop r15
pop r14
rcall set_text_layer_pointer_to_view_start
ret
;#######################################################################################################

;#######################################################################################################
;#######################################################################################################
;Routine set_text_layer_view_start
;need no delay
;needed
;t_l_view_start
;lcd_data
;#######################################################################################################
set_text_layer_view_start:

PUT_TLDATA_VIEW_START tl_data_high,tl_data_low

ret
;#######################################################################################################
;
;#######################################################################################################

;#######################################################################################################
;Routine set_text_layer_view_end
;need no delay
;needed
;tl_data
;#######################################################################################################
set_text_layer_view_end:

PUT_TLDATA_VIEW_END tl_data_high,tl_data_low

ret
;#######################################################################################################
;
;#######################################################################################################

;#######################################################################################################
;Routine set_text_layer_view_start_normal_distance
; do liked named
; substract normal distance from t_l_view_end and set to t_l_view_start
; 
;#######################################################################################################
set_text_layer_view_start_normal_distance:
push r0
push r1
push r16
push r17
clr r1
GET_TLND r0
GET_TLVARE r17,r16
SUB16 r17,r16,r1,r0
PUT_TLVARS r17,r16
pop r17
pop r16
pop r1
pop r0
ret
;#######################################################################################################
;
;#######################################################################################################



;#######################################################################################################
;Routine set_text_layer_view_end_normal_distance
; do liked named
; add normal distance from t_l_view_start and set to t_l_view_end
; 
;#######################################################################################################
set_text_layer_view_end_normal_distance:
push r0
push r1
push r16
push r17
clr r1
GET_TLND r0
GET_TLVARS r17,r16
ADD16 r1,r0,r17,r16
PUT_TLVARE r1,r0
pop r17
pop r16
pop r1
pop r0
ret
;#######################################################################################################
;
;#######################################################################################################

;#######################################################################################################
;Routine set_text_layer_pointer_to_view_start
; do liked named
;#######################################################################################################
set_text_layer_pointer_to_view_start:
push r16
push r17

;set TLPR
GET_TLVARS r17,r16
PUT_TLPR r17,r16

pop r17
pop r16
ret
;#######################################################################################################
;
;#######################################################################################################


;#######################################################################################################
;Routine set_text_layer_pointer_to_view_end
; do liked named
;#######################################################################################################
set_text_layer_pointer_to_view_end:
push r16
push r17

GET_TLVARE r17,r16
PUT_TLPR r17,r16

pop r17
pop r16
ret
;#######################################################################################################
;
;#######################################################################################################

;#######################################################################################################
;Routine put_to_text_layer (postincrement)
; no need for delay routine
; needed:
;t_l_pointer
;t_l_data
;tl_data
;puts recieved data to text layer
;#######################################################################################################
put_to_text_layer:
push r0
push r1
push r2
push r3
push r4
push r5
push r6
push r16
push r17

GET_TLALO r0
GET_TLPR r2,r1
GET_TLVARE r4,r3
GET_TLVARS r6,r5

ldi r17,0x00
clr r16
add16 r4,r3,r17,r16

cp r1,r3
cpc r2,r4
brlo put_to_text_layer_pointer_lower_end
jmp put_to_text_layer_end
put_to_text_layer_pointer_lower_end:
cp r1,r5
cpc r2,r6
brge put_to_text_layer_pointer_higher_start
jmp put_to_text_layer_end
put_to_text_layer_pointer_higher_start:
;now we now the datapointer is between start and end pointer
;and we can put the data to SRAM
PUT_TLDATA tl_data_low

;now we can increment the datapointer
INC_TLPR

;we should check if its overflowing,...
cp r1,r3
cpc r2,r4
brge put_to_text_layer_overflow
jmp put_to_text_layer_end
put_to_text_layer_overflow:

PUT_TLPR r6,r5

put_to_text_layer_end:
pop r17
pop r16
pop r6
pop r5
pop r4
pop r3
pop r2
pop r1
pop r0
ret
;#######################################################################################################
;
;#######################################################################################################

;#######################################################################################################
;Routine put_direct_to_text_layer
;only checks if the pointer points to the address room of TLDATA
;#######################################################################################################
put_direct_to_text_layer:
push r0
push r1
push r2
push r3
push r4
push r5
push r6
push r16
push r17

GET_TLALO r0
GET_TLPR r2,r1
GET_TLVARE r4,r3
GET_TLVARS r6,r5

ldi r17,0x00
clr r16
add16 r4,r3,r17,r16

cp r1,r3
cpc r2,r4
brlo put_direct_to_text_layer_pointer_lower_end
jmp put_direct_to_text_layer_end
put_direct_to_text_layer_pointer_lower_end:
cp r1,r5
cpc r2,r6
brge put_direct_to_text_layer_pointer_higher_start
jmp put_direct_to_text_layer_end
put_direct_to_text_layer_pointer_higher_start:
;now we now the datapointer is between start and end pointer
;and we can put the data to SRAM
PUT_TLDATA tl_data_low

put_direct_to_text_layer_end:
pop r17
pop r16
pop r6
pop r5
pop r4
pop r3
pop r2
pop r1
pop r0
ret
;#######################################################################################################
;
;#######################################################################################################



;#######################################################################################################
;Routine get_from_text_layer
;takes a byte from textlayer using the relative position pointer 
;and returns it to tl_data_low
;
;#######################################################################################################
get_from_text_layer:
GET_TLDATA tl_data_low
ret
;#######################################################################################################
;
;#######################################################################################################

;#######################################################################################################
;Routine get_direct_from_text_layer
;takes relativ position from prewrited lcd_data
;and returns textbyte to lcd_data
;#######################################################################################################
get_direct_from_text_layer:
PUT_TLDATA_POSITION tl_data_high,tl_data_low
GET_TLDATA tl_data_low
ret
;#######################################################################################################
;
;#######################################################################################################


;#######################################################################################################
;Routine inc_t_l_view
; increments view postion (start and end)
; its needed for scrolling effects (charwise)
; 
;#######################################################################################################
inc_t_l_view:
INC_TLVARS
INC_TLVARE
ret
;#######################################################################################################
; 
;#######################################################################################################




;#######################################################################################################
;Routine dec_t_l_view
; decrements view postion (start and end)
; its needed for scrolling effects (charwise)
; 
;#######################################################################################################
dec_t_l_view:
DEC_TLVARS
DEC_TLVARE
ret
;#######################################################################################################
; 
;#######################################################################################################





;#######################################################################################################
;Routine get_text_layer_pointer
;reads t_l_pointer and returns it to tl_data
;#######################################################################################################
get_text_layer_pointer:
GET_TLDATA_POSITION tl_data_low,tl_data_high
ret
;#######################################################################################################
;
;#######################################################################################################


;#######################################################################################################
;Routine write_text_layer_to_GGRAM
; 
;#######################################################################################################
write_text_layer_to_GGRAM:
call set_text_layer_pointer_to_view_start


write_t_l_t_G_1:
GET_TLDATA lcd_data
INC_TLPR
rcall lcd_data_trans_l
rcall get_text_layer_pointer
cpse lcd_data,r0
rjmp write_t_l_t_G_1

pop r31
pop r30
pop r0
ret
;#######################################################################################################
; 
;#######################################################################################################


#endif
;#######################################################################################################
;
;#######################################################################################################
