;#######################################################################################################
;File name: t_l_macros.mcr
;Type of File: Macro file
;Copyright: (C) Kai Scheddin
;Date: 18.07.07
;
;Description: includes needed macros for textlayer
;
;Code example: 
;
;
;ATTENTION:
;
;#######################################################################################################
#ifndef _T_L_MACROS_MCR_
#define _T_L_MACROS_MCR_


;#######################################################################################################
; MACRO's GET from DSEG vars of Text Layer Buffer
;Usage:
; MACRO_NAME REGISTER
; MACRO_NAME HIGH_REGISTER,LOW_REGISTER
;#######################################################################################################

.MACRO GET_TLCR

GET_RAM_WORD_ TLCR,@0,@1

.ENDMACRO

.MACRO GET_TLCRH

GET_RAM_BYTE_ TLCRH,@0

.ENDMACRO

.MACRO GET_TLCRL

GET_RAM_BYTE TLCRL,@0

.ENDMACRO

.MACRO GET_TLPR

GET_RAM_WORD_ TLPR,@0,@1

.ENDMACRO

.MACRO GET_TLPRH

GET_RAM_BYTE_ TLPRH,@0

.ENDMACRO

.MACRO GET_TLPRL

GET_RAM_BYTE_ TLPRL,@0

.ENDMACRO

.MACRO GET_TLVAR

GET_RAM_DWORD_ TLVAR,@0,@1,@2,@3

.ENDMACRO

.MACRO GET_TLVARS

GET_RAM_WORD_ TLVARS,@0,@1

.ENDMACRO

.MACRO GET_TLVARSH

GET_RAM_BYTE_ TLVARSH,@0

.ENDMACRO

.MACRO GET_TLVARSL

GET_RAM_BYTE_ TLVARSL,@0

.ENDMACRO

.MACRO GET_TLVARE

GET_RAM_WORD_ TLVARE,@0,@1

.ENDMACRO

.MACRO GET_TLVAREH

GET_RAM_BYTE_ TLVAREH,@0

.ENDMACRO

.MACRO GET_TLVAREL

GET_RAM_BYTE_ TLVAREL,@0

.ENDMACRO

.MACRO GET_TLDATA
push r1
push r2

GET_TLPR r2,r1

push r30
push r31

mov r30,r1
mov r31,r2

ld @0,Z

pop r31
pop r30
pop r2
pop r1
.ENDMACRO

;#######################################################################################################
;The RELATIVE POSITION MACROS
; just build the difference between the ABSOLUTE TLDATA address @ SRAM
; and the specific pointer,
;ATTENTION:
;if a pointer is manuely set lower then the TLDATA address, 
; it will return a NEGATIVE DISTANCE....
;
;
;#######################################################################################################


.MACRO GET_TLDATA_POSITION
push r28
push r29

GET_TLPR r29,r28 ; gives back the pointer to the ABSOLUTE address @ sram
movw @0:@1,r29:r28

ldi r28,low(TLDATA) 
ldi r29,high(TLDATA)
; now in r29:r28 the ABSOLUTE address @ sram of TLDATA is stored
sub @1,r28
sbc @0,r29
; substraction of each other gives relative position IN TLDATA

pop r29
pop r28
.ENDMACRO

.MACRO GET_TLDATA_VIEW_START 
push r28
push r29

GET_TLVARS r29,r28 ; gives back the pointer to the ABSOLUTE address @ sram
movw @0:@1,r29:r28

ldi r28,low(TLDATA) 
ldi r29,high(TLDATA)
; now in r29:r28 the ABSOLUTE address @ sram of TLDATA is stored
sub @1,r28
sbc @0,r29
; substraction of each other gives relative position IN TLDATA

pop r29
pop r28
.ENDMACRO

.MACRO GET_TLDATA_VIEW_END
push r28
push r29

GET_TLVARE r29,r28 ; gives back the pointer to the ABSOLUTE address @ sram
movw @0:@1,r29:r28

ldi r28,low(TLDATA) 
ldi r29,high(TLDATA)
; now in r29:r28 the ABSOLUTE address @ sram of TLDATA is stored
sub @1,r28
sbc @0,r29
; substraction of each other gives relative position IN TLDATA

pop r29
pop r28
.ENDMACRO

.MACRO GET_TLND
push r16
GET_TLCRH @0

lsr @0
lsr @0
lsr @0

ldi r16,0b00001111
and @0,r16
pop r16

.ENDMACRO

.MACRO GET_TLALO
push r16

GET_TLCRH @0

swap @0
ldi r16,0x01
and @0,r16

pop r16
.ENDMACRO

.MACRO GET_TLDATA_END
push r28
push r29
push r30
push r31

ldi r28,low(TLDATA_SIZE)
ldi r29,high(TLDATA_SIZE)
ldi r30,low(TLDATA)
ldi r31,high(TLDATA)

ADD16 r31,r30,r29,r28
movw @0:@1,r31:r30

pop r31
pop r30
pop r29
pop r28
.ENDMACRO
;#######################################################################################################
; MACRO's PUT to DSEG vars of Text Layer Buffer
;Usage:
; MACRO_NAME REGISTER
; MACRO_NAME HIGH_REGISTER,LOW_REGISTER
;#######################################################################################################

.MACRO PUT_TLCR

PUT_RAM_WORD_ TLCR,@0,@1

.ENDMACRO

.MACRO PUT_TLCRH

PUT_RAM_BYTE_ TLCRH,@0

.ENDMACRO

.MACRO PUT_TLCRL

PUT_RAM_BYTE TLCRL,@0

.ENDMACRO

.MACRO PUT_TLPR

PUT_RAM_WORD_ TLPR,@0,@1

.ENDMACRO

.MACRO PUT_TLPRH

PUT_RAM_BYTE_ TLPRH,@0

.ENDMACRO

.MACRO PUT_TLPRL

PUT_RAM_BYTE_ TLPRL,@0

.ENDMACRO

.MACRO PUT_TLVAR

PUT_RAM_DWORD_ TLVAR,@0,@1,@2,@3

.ENDMACRO

.MACRO PUT_TLVARS

PUT_RAM_WORD_ TLVARS,@0,@1

.ENDMACRO

.MACRO PUT_TLVARSH

PUT_RAM_BYTE_ TLVARSH,@0

.ENDMACRO

.MACRO PUT_TLVARSL

PUT_RAM_BYTE_ TLVARSL,@0

.ENDMACRO

.MACRO PUT_TLVARE

PUT_RAM_WORD_ TLVARE,@0,@1

.ENDMACRO

.MACRO PUT_TLVAREH

PUT_RAM_BYTE_ TLVAREH,@0

.ENDMACRO

.MACRO PUT_TLVAREL

PUT_RAM_BYTE_ TLVAREL,@0

.ENDMACRO


.MACRO PUT_TLDATA
push r1
push r2

GET_TLPR r2,r1

push r30
push r31

mov r30,r1
mov r31,r2

st Z,@0

pop r31
pop r30
pop r2
pop r1
.ENDMACRO



.MACRO PUT_TLDATA_POSITION
push r28
push r29

ldi r28,low(TLDATA)
ldi r29,high(TLDATA)

add @1,r28
adc @0,r29

PUT_TLPR @0,@1

pop r29
pop r28
.ENDMACRO

.MACRO PUT_TLDATA_VIEW_START
push r28
push r29

ldi r28,low(TLDATA)
ldi r29,high(TLDATA)

add @1,r28
adc @0,r29

PUT_TLVARS @0,@1

pop r29
pop r28
.ENDMACRO

.MACRO PUT_TLDATA_VIEW_END
push r28
push r29

ldi r28,low(TLDATA)
ldi r29,high(TLDATA)

add @1,r28
adc @0,r29

PUT_TLVARE @0,@1

pop r29
pop r28
.ENDMACRO


;#######################################################################################################
;MACROS INCrement register
;
;#######################################################################################################
.MACRO INC_TLPR
push r0
push r1
push r28
push r29

clr r1
ldi r28,0x01
mov r0,r28

GET_TLPR r29,r28
ADD16 r29,r28,r1,r0
PUT_TLPR r29,r28

pop r29
pop r28
pop r1
pop r0
.ENDMACRO

.MACRO INC_TLVARS
push r0
push r1
push r28
push r29

clr r1
ldi r28,0x01
mov r0,r28

GET_TLVARS r29,r28
ADD16 r29,r28,r1,r0
PUT_TLVARS r29,r28

pop r29
pop r28
pop r1
pop r0
.ENDMACRO

.MACRO INC_TLVARE
push r0
push r1
push r28
push r29

clr r1
ldi r28,0x01
mov r0,r28

GET_TLVARE r29,r28
ADD16 r29,r28,r1,r0
PUT_TLVARE r29,r28

pop r29
pop r28
pop r1
pop r0
.ENDMACRO

;#######################################################################################################
;MACROS DECrement register
;
;#######################################################################################################
.MACRO DEC_TLPR
push r0
push r1
push r28
push r29

clr r1
ldi r28,0x01
mov r0,r28

GET_TLPR r29,r28
SUB16 r29,r28,r1,r0
PUT_TLPR r29,r28

pop r29
pop r28
pop r1
pop r0
.ENDMACRO

.MACRO DEC_TLVARS
push r0
push r1
push r28
push r29

clr r1
ldi r28,0x01
mov r0,r28

GET_TLVARS r29,r28
SUB16 r29,r28,r1,r0
PUT_TLVARS r29,r28

pop r29
pop r28
pop r1
pop r0
.ENDMACRO

.MACRO DEC_TLVARE
push r0
push r1
push r28
push r29

clr r1
ldi r28,0x01
mov r0,r28

GET_TLVARE r29,r28
SUB16 r29,r28,r1,r0
PUT_TLVARE r29,r28

pop r29
pop r28
pop r1
pop r0
.ENDMACRO


#endif
;#######################################################################################################
;POSTSCRIPTUM:
;
;
;#######################################################################################################
