;#######################################################################################################
;Routine SM_transpose
;Transposes the matrix data from 8x5 to 5x8
;(c) Kai Scheddin
; uses follow registers
;ZH,ZL = r31:r30
;YH,YL = r29:r28
;r24 as bitmask for column mask of 5x8 matrix
;r1 as row of 8x5 matrix (also counter or rather rowindex, cause of postinc)
;r23 as counter for row index of 5x8 matrix
;r22 as overlay of stored data and seted element of 5x8 matrix
;#######################################################################################################
SM_transpose:

;#bw2 has to be completly cleared b4
;#bw2 is target
push r31
push r30
push r29
push r28
push r24
push r23
push r22
push r1

ldi r30,low(bw1)
ldi r31,high(bw1)
ldi r28,low(bw2)
ldi r29,high(bw2)


ldi r24,0b00010000          ;# bitmask and counter
reorder1:
ld r1,z+                    ;# takes row of bw1 and postinc Z pointer
ldi r28,low(bw2)
ldi r29,high(bw2)
ldi r23,8                   ;# set counter to 7
reorder2:
ld r22,y                    ;# loads bw2 
lsl r1                      ;# shift r1 left, puts msb to carry
brcc ro_carry_is_clear         
or r22,r24                  ;# sets bitmask to r22
ro_carry_is_clear:
st y+,r22                   ;# store r22 to bw2, and postinc
dec r23                     ;# dec counter
brne reorder2              ;# if NOT bw2 row 7 to 0 is set reloop else...
lsr r24                     ;# shift bitmask to right
brcc reorder1              ;# if carry is set end routine

pop r1
pop r22
pop r23
pop r24
pop r28
pop r29
pop r30
pop r31

ret
;#######################################################################################################

;#######################################################################################################
